<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use App\Models\Sublead;
use App\Models\Lead;
use App\Exports\ExportSublead;
use App\Imports\ImportSublead;
use Maatwebsite\Excel\Facades\Excel;
use Auth, DB, Mail, Validator, File, DataTables, Exception;

class SubleadController extends Controller{
    /** construct */
        public function __construct(){
            $this->middleware('permission:sub_lead-create', ['only' => ['create']]);
            $this->middleware('permission:sub_lead-edit', ['only' => ['edit']]);
            $this->middleware('permission:sub_lead-view', ['only' => ['view']]);
            $this->middleware('permission:sub_lead-delete', ['only' => ['delete']]);
        }
    /** construct */

    /** index */
        public function index(Request $request){
            if($request->ajax()){

               $data = DB::table('sub_lead as sb')
                ->select('sb.id','sb.name','sb.status','l.name as lead_name')
                ->leftjoin('lead as l', 'l.id', 'sb.lead_id')
                ->where('sb.status','!=','deleted');

                return Datatables::of($data)
                        ->addIndexColumn()
                        ->addColumn('action', function ($data) {
                            $return = '<div class="btn-group">';
    
                            if (auth()->user()->can('sub_lead-view')) {
                                $return .=  '<a href="'.route('sub_lead.view', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                    <i class="fa fa-eye"></i>
                                                </a> &nbsp;';
                            }
    
                            if (auth()->user()->can('sub_lead-edit')) {
                                $return .= '<a href="'.route('sub_lead.edit', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                    <i class="fa fa-edit"></i>
                                                </a> &nbsp;';
                            }
    
                            if (auth()->user()->can('sub_lead-delete')) {
                                $return .= '<a href="javascript:;" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown">
                                                    <i class="fa fa-bars"></i>
                                                </a> &nbsp;
                                                <ul class="dropdown-menu">
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="active" data-id="' . base64_encode($data->id) . '">Active</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="inactive" data-id="' . base64_encode($data->id) . '">Inactive</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="deleted" data-id="' . base64_encode($data->id) . '">Delete</a></li>
                                                </ul>';
                            }
    
                            $return .= '</div>';
    
                            return $return;
                        })
                        ->editColumn('status', function ($data) {
                            if ($data->status == 'active') {
                                return '<span class="badge badge-pill badge-success">Active</span>';
                            } else if ($data->status == 'inactive') {
                                return '<span class="badge badge-pill badge-warning">Inactive</span>';
                            } else if ($data->status == 'deleted') {
                                return '<span class="badge badge-pill badge-danger">Deleted</span>';
                            }else{
                                return '-';
                            }
                        })
                        ->rawColumns(['action' ,'status'])
                        ->filter(function ($query) {
                                if (request()->get('lead_name', false)) {
                                    $query->where('l.name', 'like', "%" . request()->get("lead_name") . "%");
                                }
                                if (request()->get('sub_lead_name', false)) {
                                    $query->where('sb.name', 'like', "%" . request()->get("sub_lead_name") . "%"); 
                                }
                            })
                        ->make(true);
                }
            return view('sub_lead.index');
        }
    /** index */

    /** create */
        public function create(Request $request){

            $lead_data = Lead::where(['status' => 'active'])->get();

            return view('sub_lead.create')->with(['lead_data' => $lead_data]);
        }
    /** create */

    /** insert */
        public function insert(Request $request){
            if($request->ajax()){
                return true ;
            }

            $crud = [
                'lead_id' => ucfirst($request->lead_id),
                'name' => ucfirst($request->name),
                'status' => 'active',
                'created_at' => date('Y-m-d H:i:s'),
                'created_by' => auth()->user()->id,
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth()->user()->id
            ];
            
            DB::beginTransaction();
            try {
                DB::enableQueryLog();
                $last_id = Sublead::insertGetId($crud);
                if ($last_id) {
                    
                    DB::commit();
                    return redirect()->route('sub_lead')->with('success', 'Record inserted successfully');
                } else {
                    DB::rollback();
                    return redirect()->back()->with('error', 'Failed to insert record')->withInput();
                }
            } catch (\Throwable $th) {
                DB::rollback();
                return redirect()->back()->with('error', 'Something went wrong, please try again later')->withInput();
            }
        }
    /** insert */

    /** view */
        public function view(Request $request){
            $lead_data = Lead::where(['status' => 'active'])->get();

            $id = base64_decode($request->id);
            $data = Sublead::where(['id' => $id])->first();
            return view('sub_lead.view')->with(['data' => $data,'lead_data' => $lead_data]);
        }
    /** view */

    /** edit */
        public function edit(Request $request){
            $lead_data = Lead::where(['status' => 'active'])->get(); 

            $id = base64_decode($request->id);
            $data = Sublead::where(['id' => $id])->first();
            return view('sub_lead.edit')->with(['data' => $data,'lead_data' => $lead_data]);
        }
    /** edit */

    /** update */
        public function update(Request $request){
            if($request->ajax()){
                return true;
            }

            $crud = [
                'lead_id' => ucfirst($request->lead_id) ?? 0,
                'name' => ucfirst($request->name) ?? '',
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth('sanctum')->user()->id
            ];

            DB::beginTransaction();
            try {
                $update = Sublead::where(['id' => $request->id])->update($crud);
                if ($update) {
                    DB::commit();
                    return redirect()->route('sub_lead')->with('success', 'Record updated successfully');
                } else {
                    DB::rollback();
                    return redirect()->back()->with('error', 'Failed to update record')->withInput();
                }
            } catch (\Throwable $th) {
                DB::rollback();
                return redirect()->back()->with('error', 'Something went wrong, please try again later')->withInput();
            }

           
        }
    /** update */

    /** change-status */
        public function change_status(Request $request){
            if (!$request->ajax()) { exit('No direct script access allowed'); }

                $id = base64_decode($request->id);
                $data = Sublead::where(['id' => $id])->first();

                if(!empty($data)){
                    $update = Sublead::where(['id' => $id])->update(['status' => $request->status, 'updated_at' => date('Y-m-d H:i:s'), 'updated_by' => auth()->user()->id]);
                    if($update){
                        return response()->json(['code' => 200]);
                    }else{
                        return response()->json(['code' => 201]);
                    }
                }else{
                    return response()->json(['code' => 201]);
                }
       
        }
    /** change-status */

    /** Export */
        public function export(Request $request){
            if(isset($request->slug) && $request->slug != null){
                $slug = $request->slug;
            }else{
                $slug = 'all';
            }

            $name = 'Sublead_'.Date('YmdHis').'.xlsx';

            try {
                return Excel::download(new ExportSublead($slug), $name);
            }catch(\Exception $e){
                return redirect()->back()->with('error', $e->getMessage());
            }
        }
    /** Export */
    /** Import */
    public function import(Request $request){
           
        if(Excel::import(new ImportSublead, $request->file('file')->store('file'))){
            return redirect()->route('sub_lead')->with('sucess' ,'File Imported Sucessfully');
        }else{
            return redirect()->route('sub_lead')->with('error' ,'Faild To Import File!');
        }
    }
    /** Import */
}
